#!/bin/bash
#

#
#рабочий цикл
#
_version="01.00.01"
_date="12.01.2018"

#рабочая директория
_workdir="/home/httpd/ramdisk"
#директория bash
_bashdir="/home/httpd/bash"
#директория заданий
_taskdir="/home/httpd/task"
#файл конфигурация
_fcfg="/home/httpd/config/lwork.cfg"
#
_ddir=""
((cnt_tar = 0))
_tarray=()
#
nfile=""
#
((interval=10))

function fhelp()
{
	echo -e ""
	echo -e "./lwork.sh help          - текущая подсказка"
	echo -e "./lwork.sh version       - версия"
	echo -e "./lwork.sh date          - дата изменений"
	echo -e ""
	echo -e "./lwork.sh start         - старт выполнения цикла заданий"
	echo -e "./lwork.sh kill          - удаление цикла выполнения заданий"
	echo -e "" 
}

function ftask()
{
	nfile=${_tarray[cnt_tar]}
	params=$(cat "$_taskdir/$nfile")
	#echo -e "== $nfile $params"
	if [ -f "$_bashdir/$nfile" ]; then
	 if [ ! -f "$_workdir/$nfile" ]; then
	  cp $_bashdir/$nfile $_workdir/$nfile
	 fi
	fi
	_pid=$(ps aux | pgrep $nfile)
	#echo "pid=$_pid"
	if [ "$_pid" == "" ]; then
	 $_workdir/$nfile $params
	fi
}

function ftaskarray()
{
	_tarray=$(echo -e $_ddir)
	((cnt_tar=0))
	for str in ${_ddir[@]}
	 do
	 _tarray[cnt_tar]=$str
	ftask
	((cnt_tar += 1))
	done
	echo ${#_tarray[@]}
}

function fwork()
{
	((loop = 1))
	while( ((loop > 0)) ); do
		str=$(cat $_fcfg)
        	interval=$(echo -e "$str" | grep "cfg" | awk '/lwork_interval/ {print($3)}')
		#
		_ddir=$(ls $_taskdir)
		ftaskarray
		#
		sleep $interval
	done
}

case $1 in
	"help")
		fhelp
	;;
	"version")
		echo -e "$_version"
	;;
	"date")
		echo -e "$_date"
	;;
	"start")
		fwork &
		exit 0
	;;
	"kill")
		killall -9 lwork.sh
	;;
	*)
		echo "usage $0 {help}"
	;;
esac
exit 0;

