#!/bin/bash
#

#
#выполнение команд по SSH
#
_version="01.00.01"
_date="11.01.2018"
#
strusrurl=""
strcmd=""
outstr=""
askpswd=""
fpswd=""

_localdir=""
_remotedir=""

function fhelp()
{
	echo -e ""
	echo -e "./sshcmd help                                             - текущая подсказка"
	echo -e "./sshcmd version                                          - версия"
	echo -e "./sshcmd date                                             - дата изменения"
	echo -e ""
	echo -e "./sshcmd.sh tcmd <login@IP> <password> <filepswd> <cmd>   - выполнение команд(ы) на удалённом хосте по ssh с выводом в консоль"
	echo -e "                                                          - <lodin@ip> логин и IP адрес"
	echo -e "                                                          - <passsword> пароль для входа по SSH"
	echo -e "                                                          - <filepswd> имя и путь к файлу реализации регистрации"
	echo -e "                                                            формируется и удаляется самостоятельно. В локальной директории"
	echo -e "                                                            указывать в форме: \"./filename\". Рекомендуется указывать"
	echo -e "                                                            в RAM-диске"
	echo -e "                                                          - <cmd> строка команд. Несколько команд разделены точкой с запятой \";\""
	echo -e "                                                            типа: ls;df... команды с ключём заключать в кавычки типв \"ls -al\""
	echo -e "./sshcmd.sh tohost <login@ip> <password> <filepswd> <localdir> <remotedir>"
	echo -e "                                                          - копирование директории с её содержимым в хост"
	echo -e "                                                          - <lodin@ip> логин и IP адрес"
	echo -e "                                                          - <passsword> пароль для входа по SSH"
	echo -e "                                                          - <filepswd> имя и путь к файлу реализации регистрации"
	echo -e "                                                            формируется и удаляется самостоятельно. В локальной директории"
	echo -e "                                                            указывать в форме: \"./filename\". Рекомендуется указывать"
	echo -e "                                                            в RAM-диске"
	echo -e "                                                          - <localdir> полный путь к директории с её содержимым локального"
	echo -e "                                                            хоста"
	echo -e "                                                          - <remotedir> полный путь к директории с её содержимым удалённого"
	echo -e "                                                            хоста"
	echo -e "./sshcmd.sh fromhost <login@ip> <password> <filepswd> <remotedir> <localdir>"
	echo -e "                                                          - копирование директории из хоста"
	echo -e "                                                          - копирование директории с её содержимым в хост"
	echo -e "                                                          - <lodin@ip> логин и IP адрес"
	echo -e "                                                          - <passsword> пароль для входа по SSH"
	echo -e "                                                          - <filepswd> имя и путь к файлу реализации регистрации"
	echo -e "                                                            формируется и удаляется самостоятельно. В локальной директории"
	echo -e "                                                            указывать в форме: \"./filename\". Рекомендуется указывать"
	echo -e "                                                            в RAM-диске"
	echo -e "                                                          - <remotedir> полный путь к директории с её содержимым удалённого"
	echo -e "                                                            хоста"
	echo -e "                                                          - <localdir> полный путь к директории с её содержимым локального"
	echo -e "                                                            хоста"
	echo -e "" 
}

#копирование директории на удалённый хост
function scpdirtoremote()
{
	export DISPLAY=:0; export SSH_ASKPASS=$fpswd;
	setsid scp -r $_localdir $strusrurl:$_remotedir
}

#копирование директории на локальный хост
function scpdirtolocal()
{
	export DISPLAY=:0; export SSH_ASKPASS=$fpswd;
	setsid scp -r $strusrurl:$_remotedir $_localdir
}

#выполнение команд на удалённом хосте
function fcmdwork()
{
outstr=$(
export DISPLAY=:0; export SSH_ASKPASS=$fpswd;
setsid ssh -o StrictHostKeyChecking=no -T $strusrurl << EOF 2>&1
$strcmd
EOF
)
}


case $1 in
	"help")
		fhelp
	;;
	"version")
		echo "$_version"
	;;
	"date")
		echo "$_date"
	;;
	"tcmd")
		strusrurl=$2
		askpswd=$3
		fpswd=$4
		strcmd=$5
		echo -e "#!/bin/bash\n\necho \"$askpswd\"\n" > $fpswd
		chmod +x $fpswd
		fcmdwork
		echo -e "$outstr"
		rm $fpswd
	;;
	"tohost")
		strusrurl=$2
		askpswd=$3
		fpswd=$4
		_localdir=$5
		_remotedir=$6
		echo "$strusrurl $askpswd $fpswd $_localdir $_remotedir" 
		echo -e "#!/bin/bash\n\necho \"$askpswd\"\n" > $fpswd
		chmod +x $fpswd
		scpdirtoremote
		rm $fpswd
	;;
	"fromhost")
		strusrurl=$2
		askpswd=$3
		fpswd=$4
		_remotedir=$5
		_localdir=$6
		echo "$strusrurl $askpswd $fpswd $_localdir $_remotedir" 
		echo -e "#!/bin/bash\n\necho \"$askpswd\"\n" > $fpswd
		chmod +x $fpswd
		scpdirtolocal
		rm $fpswd
	;;
	*)
		echo "usage $0 {help}"
	;;
esac
exit 0


